;--------------------------------------------------------
;       SetTone         
;--------------------------------------------------------
SetTone         PROC   near             ; ax= tone
                push    dx
                mov     DX,03FDBh       ; 3FDB
                out     DX,AL
                out     5Fh,al
                xchg    AL,AH
                out     DX,AL
                out     5Fh,al
                pop     dx
                ret
SetTone         ENDP

;--------------------------------------------------------
;       Poop
;--------------------------------------------------------
Poop            PROC   near
                mov     ax,4400       ; low freq.
                call    SetTone
                mov     al,6            ; BEEP ON
                out 37h,al              
                mov     cx,6543h 
        @@:     out     5Fh,al  ; ҂
                out     5Fh,al
               loop     @b
                mov     al,7            ; BEEP OFF
                out 37h,al              
                mov     ax,04CDh        ; normal freq.
                call    SetTone
                ret
Poop            ENDP


;--------------------------------------------------------------+----------+
;       Scan_GRPH_FK  [FE1]`[FE7]L[Ń[hIEL   | 2024/3/29|
; L[Ԃ݂    keycode   e[h̊OlɑΉ |          |
;--------------------------------------------------------------+----------+
Scan_GRPH_FK   PROC   near
                mov     cx,7777
        @@:     mov     ah,2
                int 18h
                test    al,00001000b    ; 1=SHIFT, 8=GRPH
                jnz     EnterValue
                test    al,00010000b    ; 16=CTRL
                jnz     CancelProgram
               loop     @b      ; wait
                jmp     ScanFKEY_abort
EnterValue:     
                inc     ROW
                mov     COLUMN,0
                mov     dx,offset EnterModeValue
                call    _puts
                call    Poop            ; ````
                xor     ax,ax   ; wait while keybord input 
                int 18h         ; return: AL=key DATA, AH=key CODE
                xchg    al,ah   ; with key CODE       1   2   3   4   5   6   7
                cmp     al,62h  ; key Code 62h=[F.1] 62h,63h,64h,65h,66h,67h,68h
                jb      ScanFKEY_abort  ;  `   `
                cmp     al,68h  ; key Code 68h=[F.7]
                ja      ScanFKEY_abort
                sub     al,61h          ; -61hOlƂȂ
                mov     ah,al           ; AH=Ol
                dec     al              ; AL=lɕϊ(-1)
                and     al,00000111b    ; Mask for safety
                mov     ModeID,al       ; [hlm肷
                
                mov     al,ah           ; Ol
                call    digitx1         ; ̒l\
                
;                push    ax

                mov     al,ModeID  ; p[^[h̒l\(1`7)
                call    Poop            ; ````
                dec     ROW
                mov     COLUMN,0        ; JOɂ
                
                call    EnableSerialROM ; register ax,dx is preserved.
                ; AL=internal 
                mov     dx,891Eh        ; Read
                in      al,dx
                and     al,11101000b    ;  bit 0,1,2 gpC4GBCFp bit 4 gp
                or      al,ModeID       ;  }XN AHƂor
                call    Write891E
                call    DisableSerialROM
IF 0
                mov     al,0Dh          ; XCb`\ɂ
                out 68h,al
                pop     ax
                mov     bx,3FF6h        ; XCb`U
                mov     al,es:[bx]      ; XCb`Uǂݍ
                and     al,11111000b    ; ̃rbgۑ̃}XN
                or      al,ah           ; AH=[hlOl
                mov     es:[bx],al      ; XCb`Uɏ
                mov     al,0Ch          ; XCb`֎~ɂ
                out 68h,al
ENDIF
ScanFKEY_abort: clc
                ret
CancelProgram:  stc
                ret
EnterModeValue  DB      0C3h,"CHSҰ Ӱނ ==> [F1]`[F7]",0
Scan_GRPH_FK   ENDP

;---------------------------------------
; \tgEFAfBbvXCb`05 ax
Write891E       PROC   near
                and     al,7Fh
                jnp     @f
                or      al,80h
            @@: mov     dx,891Eh
                out     dx,al
                mov     ah,al
                mov     dx,5601h
                mov     cl,05h  ; =891E
                call    MemorizeDIPSW
                mov     al,ah
                out     0A9h,al
                ret     
Write891E       ENDP

;---------------------------------------
EnableSerialROM    PROC   near
        push    dx
        push    ax
        mov     dx,18F0h
        mov     ax,0017h
        out     dx,ax
        out     5Fh,al
        out     5Fh,al
        mov     dx,18F2h
        mov     ax,0001h
        out     dx,ax
        out     5Fh,al
        out     5Fh,al
        pop     ax
        pop     dx
        ret
EnableSerialROM    ENDP
;-----------------------------
DisableSerialROM   PROC   near
        mov     dx,18F0h
        mov     ax,0017h
        out     dx,ax
        out     5Fh,al
        out     5Fh,al
        mov     dx,18F2h
        mov     ax,0000h
        out     dx,ax
        out     5Fh,al
        out     5Fh,al
        ret
DisableSerialROM   ENDP
;-----------------------------
MemorizeDIPSW   PROC   near
                pushf
                cli
                mov     al,cl
                shr     al,04h
                add     al,dl
                out     0A1h,al
                mov     al,dh
                and     al,7Fh
                out     0A3h,al
                mov     al,dh
                and     al,80h
                shr     al,02h
                and     cl,0Fh
                add     al,cl
                out     0A5h,al
                out     5Fh,al
                out     5Fh,al
                in      al,0A9h
                popf
                ret 
MemorizeDIPSW   ENDP

